#include <cstdio>
#include <cstring>
#include <iostream>
#define MAX_N 20
using namespace std;
int uz[1 << MAX_N];
int C[1 << MAX_N];

int main() {
  int i, j, k, n, m, crt, inc, sf, kt;
  int masca[MAX_N + 1];
  int nr0;
  /* read the number */
  cin >> n >> kt;
  int sol = 1 << (kt - 1);
  /* read the initial configuration
     and determine in the variable nr0 the corresponding integer */
  nr0 = 0;
  for (j = 0; j < n; j++) {
    cin >> k;
    nr0 |= k << j;
  }
  /* for each po that become 0
     and determine the corresponding mask */
  for (i = 0; i < n; i++) {
    cin >> m;
    crt = 0;
    for (j = 0; j < m; j++) {
      cin >> k;
      crt |= 1 << (k - 1);
    }
    masca[i] = crt;
  }

  for (i = 0; i < (1 << n); i++) uz[i] = -1;

  /* initially, the queue C contains the initial configuration nr0 */
  inc = sf = 0;
  uz[nr0] = 0;
  C[sf] = nr0;
  while (inc <= sf && uz[sol] == -1)
  /* while we did not obtain the final configuration */
  {
    crt = C[inc++];
    for (i = 0; i < n; i++)
      if (!((crt >> i) & 1))
      // the ith bit is 0, so it correspond to a poz =0
      {
        j = (crt & ~masca[i]) | (1 << i);
        /* if we select the poz i, we get the configuration j */
        if (uz[j] == -1)
        /* if the configuration j was not obtained before */
        {
          uz[j] = uz[crt] + 1;
          /* we store the minimum number of necessary selections */
          C[++sf] = j;
        } /* insert the configuration j in the queue C */
      }
  }
  if (uz[sol] >= 0)
    cout << uz[sol] << '\n';
  else
    abort();
  return 0;
}
