// Solution of tickets of edomora97
// Complexity: O(1)
//
// K >= sum(i from 1 to N) = N*(N+1)/2 = N^2/2 + N/2
// N^2 + N - 2*K <= 0
// N >= (-1 + sqrt( 1 + 8*K )) / 2
// N >= (sqrt(8K+1) - 1)/2

#include <cmath>
#include <iostream>

int main() {
    int64_t K;
    std::cin >> K;
    int64_t N = (std::sqrt(8 * K + 1) - 1) / 2;
    std::cout << N << std::endl;
}
